package com.example.happy_bird;

import java.awt.*;
import java.util.Random;

public class GameObject {
    int x, y, width, height;
    Rectangle topPipe, bottomPipe;
    int distance = 105;
    boolean isPassedOn = false;

    // Objekt Initialisierung
    public GameObject(int x, int y, int width, int height) {
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
        topPipe = new Rectangle(x, y, width, height);
        bottomPipe = new Rectangle(x, height + distance, width, height);
    }

    // Auf Anfangs Position setzen
    public void resetToNewPosition(int newX) {
        topPipe.x = newX;
        bottomPipe.x = newX;
        x = newX;
        topPipe.y = -(new Random().nextInt(140) + 100);
        bottomPipe.y = topPipe.y + height + distance;
        isPassedOn = false;
    }

    // Prüfung ob Rectangle true oder false ist
    public boolean intersect(Rectangle rectangle) {
        return rectangle.intersects(topPipe) || rectangle.intersects(bottomPipe);
    }

    // Röhren Counter → Check, wenn Röhre durchflogen ist
    public boolean passedOn(Rectangle rectangle) {
        return rectangle.x > x + width && !isPassedOn;
    }

    // Bei Bewegung der X Koordinate werden Röhren generiert
    public void moveX(int dx) {
        x -= dx;
        topPipe.x -= dx;
        bottomPipe.x -= dx;
    }
}